unit clutprefs;
{$include options.inc}
interface
 {$IFDEF FPC}{$mode DELPHI}{$H+}{$ENDIF}
uses
{$IFDEF FPC}Spin,LResources,GLViewer,
  {$ELSE}
   Windows,GLWin32Viewer, Mask, RXSpin,
  {$ENDIF}
{$IFDEF GLSCENEOLD}
GLMisc,
{$ELSE}
BaseClasses,GLCoordinates,GLMaterial,
{$ENDIF}
  Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  GLScene, GLObjects,  Buttons, ToolWin, ComCtrls,
   VectorGeometry, OpenGL1x, Spline, VectorLists, GLGraph,clut, StdCtrls,
  ExtCtrls, GLTexture, GLGeomObjects,define_types,inifiles,
  GLBitmapFont, GLWindowsFont, GLHUDObjects, GLGui, GLWindows, GLBlur,GLCanvas,
  GLCrossPlatform;
{$IFNDEF FPC}
type
  TCLUTform = class(TForm)
    ALabelText: TGLHUDText;
    CLUTOpenDialog: TOpenDialog;
    ClutSaveDialog: TSaveDialog;
    ColorDialog1: TColorDialog;
    GLCamera1: TGLCamera;
    GLInsetGrid: TGLXYZGrid;
    GLLeftLine: TGLLines;
    GLMaxText: TGLHUDText;
    GLMinText: TGLHUDText;
    GLPolygon1: TGLPolygon;
    GLPolygonInset: TGLPolygon;
    GLRightLine: TGLLines;
    GLScene1: TGLScene;
    GLSceneViewer1: TGLSceneViewer;
    GLWindowsBitmapFont1: TGLWindowsBitmapFont;
    HelpBtn: TSpeedButton;
    HLabelText: TGLHUDText;
    Lines1: TGLLines;
    LoadBtn: TSpeedButton;
    LUTDrop: TComboBox;
    MaxEdit: TRxSpinEdit;
    MinEdit: TRxSpinEdit;
    SaveBtn: TSpeedButton;
    ToolBar1: TToolBar;
    WindowGrid: TGLXYZGrid;
    procedure UpdateColorSchema;
    procedure GLSceneViewer1MouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure GLSceneViewer1MouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure AddNode(lN: TCLUTnode);
    procedure DrawCLUTa(lLUT: TCLUTrec);
    procedure DrawCLUTf;
    procedure DrawHistoX (var lPoly: TGLPolygon; var lHisto: HistoRA; lLs,lBs,lWs,lHs: single);
    procedure MidPoly (var lPoly: TGLPolygon; lMid,lWid: single);
    procedure MidGrid (var lPoly: TGLXYZGrid; lMid,lWid: single);
    function AddColorNode (lIntensity: byte) : integer;
    procedure NodePos (lMid,lWid: single);
    procedure GLSceneViewer1DblClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure LUTDropChange(Sender: TObject);
    procedure ShowInset;
    procedure HelpBtnClick(Sender: TObject);
    procedure MinEditChange(Sender: TObject);
    procedure MaxEditChange(Sender: TObject);
    procedure SaveBtnClick(Sender: TObject);
    procedure LoadBtnClick(Sender: TObject);
    procedure HistogramColors;
    procedure MinMax(lMin,lMax: single);
  private
{$ELSE}
type
  TCLUTForm = class(TForm)

    Alabel: TGLHUDText;
    CLUTOpenDialog: TOpenDialog;
    CLUTSaveDialog: TSaveDialog;
    ColorDialog1: TColorDialog;
    GLCamera1: TGLCamera;
    GLInsetGrid: TGLXYZGrid;
    GLLeftLine: TGLLines;
    GLMaxText: TGLHUDText;
    GLMinText: TGLHUDText;
    GLPolygon1: TGLPolygon;
    GLPolygonInset: TGLPolygon;
    GLRightLine: TGLLines;
    GLScene1: TGLScene;
    GLSceneViewer1: TGLSceneViewer;
    GLWindowsBitmapFont1: TGLWindowsBitmapFont;
    HelpBtn: TSpeedButton;
    HLabelText: TGLHUDText;
    Lines1: TGLLines;
    LoadBtn: TSpeedButton;
    LUTdrop: TComboBox;
    MaxEdit: TFloatSpinEdit;
    MinEdit: TFloatSpinEdit;
    SaveBtn: TSpeedButton;
    ToolBar1: TToolBar;
    WindowGrid: TGLXYZGrid;
    procedure UpdateColorSchema;
    procedure GLSceneViewer1MouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure GLSceneViewer1MouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure AddNode(lN: TCLUTnode);
    procedure DrawCLUTa(lLUT: TCLUTrec);
    procedure DrawCLUTf;
    procedure DrawHistoX (var lPoly: TGLPolygon; var lHisto: HistoRA; lLs,lBs,lWs,lHs: single);
    procedure MidPoly (var lPoly: TGLPolygon; lMid,lWid: single);
procedure MidGrid (var lPoly: TGLXYZGrid; lMid,lWid: single);
    function AddColorNode (lIntensity: byte) : integer;
    procedure NodePos (lMid,lWid: single);
    procedure GLSceneViewer1DblClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure LUTDropChange(Sender: TObject);
    procedure ShowInset;
    procedure HelpBtnClick(Sender: TObject);
    procedure MinEditChange(Sender: TObject);
    procedure MaxEditChange(Sender: TObject);
    procedure SaveBtnClick(Sender: TObject);
    procedure LoadBtnClick(Sender: TObject);
    //procedure FormResize(Sender: TObject);
    procedure HistogramColors;
    procedure MinMax(lMin,lMax: single);
  private
{$ENDIF}
  public
    procedure MoveCenterNodeTo(x, y : Integer);
  end;

var
  CLUTform: TCLUTform;

implementation

uses mainunit,histogram, prefs;
{$IFNDEF FPC} {$R *.dfm}   {$ENDIF}
var
  gMainVCenter: single;
  gSelectedNode: integer;

procedure TCLUTform.MoveCenterNodeTo(x, y : Integer);
begin
   Lines1.Nodes[1].AsAffineVector:=GLSceneViewer1.Buffer.ScreenToWorld(x, y);
end;
const
  kByteMult = 1/255;
  kByteMult2 = 1/255;
function Screen2ByteX ( lX: single): byte;
var
  lF: single;
begin
  lF := ((lX + 0.5) * 255);
  if lF > 255 then
    lF := 255;
  if lF < 0 then
    lF := 0;
  result := round(lF);
end;

function Screen2ByteY ( lY: single): byte;
var
  lX,lF: single;
begin
  lX := lY - gMainVCenter;

  lF := ((lX + 0.5) * 255);
  if lF > 255 then
    lF := 255;
  if lF < 0 then
    lF := 0;
  result := round(lF);
end;

procedure DeleteScrnNode (lSelectedNode: integer);
var
  lN: integer;
begin
  if (lSelectedNode = 0) or (lSelectedNode >= (gCLUTrec.numnodes-1)) then
    exit; //out of range or edge node...
  dec(gCLUTrec.numnodes); //if 3 now only 2...
  if lSelectedNode < (gCLUTrec.numnodes) then begin
    for lN := lSelectedNode to (gCLUTrec.numnodes-1) do
      gCLUTrec.nodes[lN] := gCLUTrec.nodes[lN+1];
  end;
end;

procedure InterpolateRGBA(var lC1,lC2,lMix: TGLRGBQuad);
begin
  lMix.rgbRed := (lC1.rgbRed + lC2.rgbRed) shr 1;
  lMix.rgbGreen := (lC1.rgbGreen + lC2.rgbGreen) shr 1;
  lMix.rgbBlue := (lC1.rgbBlue + lC2.rgbBlue) shr 1;
end;

function TCLUTform.AddColorNode (lIntensity: byte) : integer;
var
  lP,lI,lInten: integer;
begin
  lInten := lIntensity;
  result := -1;//error
  if (lInten <= gCLUTrec.nodes[0].intensity) then
    exit;
  if (lInten >= gCLUTrec.nodes[gCLUTrec.numnodes-1].intensity) then
    exit;
  lP := gCLUTrec.numnodes-1;
  while lInten < gCLUTrec.nodes[lP].intensity do
    dec(lP);
  if  abs(gCLUTrec.nodes[lP].intensity-gCLUTrec.nodes[lP+1].intensity) < 2 then
    exit;
  if lInten = gCLUTrec.nodes[lP].intensity then
    lInten := gCLUTrec.nodes[lP].intensity+1;
  if lInten = gCLUTrec.nodes[lP+1].intensity then
    lInten := gCLUTrec.nodes[lP+1].intensity-1;
  inc(lP);//location of new node
  inc(gCLUTrec.numNodes);
  for lI := (gCLUTrec.numnodes-1) downto (lP+1) do
    gCLUTrec.nodes[lI] := gCLUTrec.nodes[lI-1];
  gCLUTrec.nodes[lP].intensity := lInten;
  result := lP;
end;

procedure AddScrnNode(lPt: TAffineVector);
var
  lB,lP: integer;
begin
  if gCLUTrec.numnodes < 2 then exit;
  if gCLUTrec.numnodes >= 255 then
    exit;
  //only add node between min and max - not more extreme!
  lB := Screen2ByteX(lPt[0]);
  if (lB <= gCLUTrec.nodes[0].intensity) then
    exit;
  if (lB >= gCLUTrec.nodes[gCLUTrec.numnodes-1].intensity) then
    exit;
  lP := CLUTForm.AddColorNode(lB);
  if lP < 0 then
    exit;
  lB := Screen2ByteY(lPt[1]);
  gCLUTrec.nodes[lP].rgba.rgbreserved := lB;
    InterpolateRGBA(gCLUTrec.nodes[lP-1].rgba,gCLUTrec.nodes[lP+1].rgba,gCLUTrec.nodes[lP].rgba);
end;

procedure TCLUTform.GLSceneViewer1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  lI,lB: integer;
  lDx,lDx2: single;
  lPt: TAffineVector;
begin
   gSelectedNode := 0;
   if gCLUTrec.numNodes < 2 then
    exit;
   lPt:=GLSceneViewer1.Buffer.ScreenToWorld(x, y);
    if  (SSCtrl in Shift) then begin //remove node
      AddScrnNode(lPt);
      DrawCLUTf;
      gSelectedNode := -1;
      exit;
   end;
   lB := Screen2ByteX(lPt[0]);
   lDx := (lB - gCLUTrec.nodes[0].intensity);
   for lI := 1 to (gCLUTrec.numnodes-1) do begin
    lDx2 := (lB - gCLUTrec.nodes[lI].intensity);
    if abs(lDx2) < abs(lDx) then begin
      gSelectedNode := lI;
      lDx := lDx2;
    end;
   end; //check each node...
   if  (SSShift in Shift) then begin //remove node
      DeleteScrnNode(gSelectedNode);
      DrawCLUTf;
      gSelectedNode := -1;
   end;
end;

procedure TCLUTform.GLSceneViewer1MouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var
    lPt: TAffineVector;
    lB: integer;
begin
   if not (SSLeft in Shift) then
    exit;
   lPt:=GLSceneViewer1.Buffer.ScreenToWorld(x, y);
   if (gCLUTrec.numNodes < 1) or (gSelectedNode < 0) or (gCLUTrec.numnodes <= gSelectedNode  ) then
    exit;
   lB := Screen2ByteY(lPt[1]);
   gCLUTrec.nodes[gSelectedNode].rgba.rgbReserved := lB;
   if (gSelectedNode > 0) and (gSelectedNode <(gCLUTrec.numnodes-1)) then begin
    lB := Screen2ByteX(lPt[0]);
    if gSelectedNode > 0 then begin
      if lB <= gCLUTrec.nodes[gSelectedNode-1].intensity then
        lB := gCLUTrec.nodes[gSelectedNode-1].intensity+1;
    end;
    if gSelectedNode < (gCLUTrec.numnodes-1) then begin
      if lB >= gCLUTrec.nodes[gSelectedNode+1].intensity then
        lB := gCLUTrec.nodes[gSelectedNode+1].intensity-1;
    end;
    gCLUTrec.nodes[gSelectedNode].intensity := lB;
   end;//node not first or last (min node must be zero, max node must be 255)
   DrawCLUTf;
end;


procedure TCLUTform.GLSceneViewer1DblClick(Sender: TObject);
begin
   if (gCLUTrec.numNodes < 1) or (gSelectedNode < 0) or (gCLUTrec.numNodes <= gSelectedNode  ) then
    exit;
   ColorDialog1.Color := RGBA2TColor(gCLUTrec.nodes[gSelectedNode].rgba);
   if not ColorDialog1.Execute then
    exit;
   TColor2RGBA(ColorDialog1.Color, gCLUTrec.nodes[gSelectedNode].rgba);
   DrawCLUTf;
end;

procedure TCLUTform.AddNode(lN: TCLUTnode);
var
  Node : TGLLinesNode;
begin
  Node:=TGLLinesNode(Lines1.Nodes.Add);
  Node.X:=lN.intensity * kByteMult2-0.5;
  Node.Y:=lN.rgba.rgbReserved * kByteMult2-0.5+ gMainVCenter;
  Node.Z:=0;
  Node.Color.Red:=lN.rgba.rgbRed*kByteMult;
  Node.Color.Blue:=lN.rgba.rgbBlue*kByteMult;
  Node.Color.Green:=lN.rgba.rgbGreen*kByteMult;
  Node.Color.Alpha:=255;
end;

procedure PolyNode(var lPoly: TGLPolygon; lIndex: integer; lX,lY: single);
begin
  lPoly.Nodes[lIndex].X := lX;
  lPoly.Nodes[lIndex].Y := lY;
end;

procedure TCLUTform.DrawHistoX (var lPoly: TGLPolygon; var lHisto: HistoRA; lLs,lBs,lWs,lHs: single);
var
  lMax,lC: integer;
  lLUTWidth,lL,lHt: single;
begin
  (*lC := 0;
  while (lC < kHistoBins) and (lHisto[lC] = 0) do
    inc(lC);
  caption := inttostr(lC)+'  '+inttostr(random(888));*)
  lMax :=lHisto[0];
  for lC := 0 to kHistoBins do begin
    if lHisto[lC] > lMax then
      lMax := lHisto[lC];
  end;
  if lMax < 1 then
    lMax := 1;
  while lPoly.Nodes.Count < (kHistoBins+3) do
        lPoly.Nodes.Add; //+3 as we need 0th bin and two bottom corners
  lL := lLs;
  lLUTWidth := lWs / (kHistoBins+1);
  for lC := 0 to kHistoBins do begin
      lHt := lHisto[lC]/lMax * lHs;
      PolyNode(lPoly,lC,lL,lBs+lHt);
      lL := lL + lLUTWidth;
  end;
  PolyNode(lPoly,kHistoBins+1,lL,lBs);
  PolyNode(lPoly,kHistoBins+2,lLs,lBs);
end;

const
  kScale = 1.9;


(*procedure AddNodeX (var lLine: TGLLines; lX,lY: single; lC: TGLRGBQuad);
var
  Node : TGLLinesNode;
begin
  //GLLeftLine.Nodes[0].X := (lMid*kScale) - 0.5*(lWid*kScale);
  //GLRightLine.Nodes[0].X := (lMid*kScale) + 0.5*(lWid*kScale);
  //while GLRightLine.Nodes.Count > 0 do
  //  GLRightLine.Nodes.Delete(0);
  //AddNodeX(GLRightLine,);

  Node:=TGLLinesNode(lLine.Nodes.Add);
  Node.X:=lX;
  Node.Y:=lY;
  Node.Z:=0;
  Node.Color.Red:=lC.rgbRed;
  Node.Color.Blue:=lC.rgbBlue;
  Node.Color.Green:=lC.rgbGreen;
  Node.Color.Alpha:=lC.rgbReserved;
end;*)

procedure TCLUTform.NodePos (lMid,lWid: single);
begin
  GLLeftLine.Nodes[0].X := (lMid*kScale) - 0.5*(lWid*kScale);
  GLRightLine.Nodes[0].X := (lMid*kScale) + 0.5*(lWid*kScale);
end;

procedure TCLUTform.MidPoly (var lPoly: TGLPolygon; lMid,lWid: single);
begin
  lPoly.Scale.X := lWid*kScale;
  lPoly.Position.X := lMid*kScale;
end;

procedure TCLUTform.MidGrid (var lPoly: TGLXYZGrid; lMid,lWid: single);
begin
//The GLScene for Lazarus is built from beta branch
//it fixes a problem in the stable build of GLScene for Delphi
{$IFDEF FPC}
  lPoly.Scale.X := lWid*kScale;
  lPoly.Position.X := lMid*kScale;
{$ELSE}
  lPoly.Scale.Y := lWid*kScale;
  lPoly.Position.X := lMid*kScale;
{$ENDIF}
end;

procedure IntenLabel (lMinIn,lMaxIn: single; var lDecimals: integer);
//special: if lMin=lMax, assumes current window values
var
	lDesiredSteps,lPower: integer;
	lMin,lMax,lRange,lStepSize: single;
begin
	 lMin := lMinIn;
	 lMax := lMaxIn;
	//next: compute increment
	lDesiredSteps := 4;
   if lMin = lMax then exit;
   lRange := abs(lMax - lMin);
   //if lRange = 0 then exit;
   if lRange < 0.000001 then exit;
   lStepSize := lRange / lDesiredSteps;
   lPower := 0;
   while lStepSize >= 10 do begin
	   lStepSize := lStepSize/10;
	   inc(lPower);
   end;
   while lStepSize < 1 do begin
	   lStepSize := lStepSize * 10;
	   dec(lPower);
   end;
   if lPower < 0 then
	    lDecimals := -lPower
   else
	    lDecimals := 0;
end;

procedure TCLUTform.ShowInset;
const
  lVFrame = 0.05;
var
  lDecimals: integer;
  lCLUTMin,lCLUTMax,lMin,lMax,lRange,lL,lR,lWid,lMid: single;
begin
  lCLUTMin := gCLUTrec.min;
  lCLUTMax := gCLUTrec.max;
  if lCLUTMin > lCLUTMax then begin
    lCLUTMax := gCLUTrec.min;
    lCLUTMin := gCLUTrec.max;
  end;
  lMin := gTexture3D.WindowScaledMin;
  if (lCLUTMin < lMin) then
    lMin := lCLUTMin;
  lMax := gTexture3D.WindowScaledMax;
  if (lCLUTMax > lMax) then
    lMax := lCLUTMax;
  lRange := abs(lMax-lMin);
  //InsetText;
  IntenLabel (lMin,lMax, lDecimals);
  GLMinText.Text := RealToStr(lMin,lDecimals);
  GLMaxText.Text := Realtostr(lMax,lDecimals);
  lL := (gTexture3D.WindowScaledMin-lMin)/lRange;
  lR := ((gTexture3D.WindowScaledMax-lMin)/lRange);
  lWid := lR-lL;
  lMid := (lL+lR) /2;
  MidPoly (GLPolygonInset,lMid-0.5,lWid);
  lL := (lCLUTMin-lMin)/lRange;
  lR := ((lCLUTMax-lMin)/lRange);
  lWid := lR-lL;
  lMid := (lL+lR) /2;
  MidGrid (GLInsetGrid,lMid-0.5,lWid);
  NodePos(lMid-0.5,lWid);
end;

procedure TCLUTform.DrawCLUTf;
begin
  GLForm1.CLUTTimerXOn;
end;

procedure ChangeCLUTMinMax;
begin
  CreateHisto(gTexture3D, gCLUTrec.min,gCLUTrec.max, gTexture3D.WindowHisto, true);
end;

procedure TCLUTform.DrawCLUTa(lLUT: TCLUTrec);
var
  lI : integer;
begin
  ChangeCLUTMinMax;
  while Lines1.Nodes.Count > 0 do
    Lines1.Nodes.Delete(0);
  for lI := 0 to (gCLUTrec.numnodes-1) do
    AddNode(lLUT.nodes[lI]);
  DrawHistoX (GLPolygon1,gTexture3D.WindowHisto, -0.5,-0.1,1,1);
  ShowInset;
end;

procedure TCLUTform.FormHide(Sender: TObject);
begin
//  GLSceneViewer1.enabled := false;
end;

procedure TCLUTform.LUTDropChange(Sender: TObject);
begin
  if LUTdrop.ItemIndex = 0 then
    AutoContrast (gCLUTrec)
  else
     CLUT2disk(true,ClutDir+pathdelim+LUTdrop.Items[LUTdrop.ItemIndex]+'.clut', gCLUTrec);
  if (gCLUTrec.min = gCLUTrec.max) then
    RangeRec(gTexture3D.MinThreshScaled,gTexture3D.MaxThreshScaled);

  MinEdit.value := gCLUTrec.min;
  MaxEdit.value := gCLUTrec.max;
    GLForm1.CLUTTimerXOn;
end;


procedure TCLUTform.UpdateColorSchema;
//var
//	lSearchRec: TSearchRec;
//  lS: TStringList;
begin
  LUTdrop.Items.Clear;
  LUTdrop.Items.Add('Grayscale');
  UpdateColorSchemes(LUTdrop);
end;//UpdateColorSchema


procedure TCLUTform.FormCreate(Sender: TObject);
begin
  UpdateColorSchema;
  LUTDrop.ItemIndex := 0;
  gMainVCenter := WindowGrid.Position.Y;
  CLUTOpenDialog.initialdir := CLUTDir;
  CLUTSaveDialog.initialdir := CLUTDir;
end;

(*procedure AddNodeZ (var lLine: TGLLines; lX,lY: single; lC: TGLRGBQuad);
var
  Node : TGLLinesNode;
begin
  Node:=TGLLinesNode(lLine.Nodes.Add);
  Node.X:=lX;
  Node.Y:=lY;
  Node.Z:=0;
  Node.Color.Red:=lC.rgbRed;
  Node.Color.Blue:=lC.rgbBlue;
  Node.Color.Green:=lC.rgbGreen;
  Node.Color.Alpha:=255;
end;

procedure LineColor (var lLine: TGLLines;lC: TGLRGBQuad);
var
  lX0,lY0,lX1,lY1: single;
begin
  lX0 := lLine.Nodes[0].X;
  lY0 := lLine.Nodes[0].Y;
  lX1 := lLine.Nodes[1].X;
  lY1 := lLine.Nodes[1].y;
  while lLine.Nodes.Count > 0 do
    lLine.Nodes.Delete(0);
  AddNodeZ(lLine,lX0,lY0,lC);
  AddNodeZ(lLine,lX1,lY1,lC);
end;

function T2G(lColor: TColor): TGLRGBQuad;
begin
  TColor2RGBA (lColor,result);
end; *)

procedure TCLUTform.HistogramColors;
begin
  WindowGrid.LineColor.aswincolor :=gPrefs.CLUTWindowColor;
  GLInsetGrid.LineColor.aswincolor :=gPrefs.CLUTWindowColor;
  GLPolygonInset.Material.FrontProperties.Emission.AsWinColor := gPrefs.CLUTIntensityColor;
  GLPolygon1.Material.FrontProperties.Emission.AsWinColor := gPrefs.CLUTIntensityColor;
  GLPolygon1.Material.FrontProperties.Diffuse.Alpha := 0.8;
  GLPolygon1.Material.BlendingMode := bmAdditive;

  //caption := inttostr(random(888))+'  '+ inttostr(gPrefs.CLUTWindowColor);
  //LineColor (GLLeftLine, T2G( gPrefs.CLUTWindowColor));
  //LineColor (GLRightLine, T2G( gPrefs.CLUTWindowColor));
end;

procedure TCLUTform.FormShow(Sender: TObject);
begin
  HistogramColors;
end;


procedure TCLUTform.HelpBtnClick(Sender: TObject);
begin
  Showmessage('Use mouse to change node intensity and transparency, double click to adjust color, control click to add nodes, shift click to delete nodes.');
end;

procedure TCLUTform.MinMax(lMin,lMax: single);
begin
    {x$IFNDEF Darwin}
    MinEdit.value := lMin;
    {x$ENDIF}
    MaxEdit.value := lMax;
end;

procedure TCLUTform.MinEditChange(Sender: TObject);
begin
  if Sender = nil then
     exit;
  gCLUTrec.min := MinEdit.value;
    GLForm1.CLUTTimerXOn;
  //CLUTTime.enabled := true;
end;

procedure TCLUTform.MaxEditChange(Sender: TObject);
begin
  if Sender = nil then
     exit;
  gCLUTrec.max := MaxEdit.value;
  GLForm1.CLUTTimerXOn;
end;

procedure TCLUTform.SaveBtnClick(Sender: TObject);
begin
  if not ClutSaveDialog.Execute then
    exit;
  CLUT2disk(false,ClutSaveDialog.filename,gCLUTrec);
end;

procedure TCLUTform.LoadBtnClick(Sender: TObject);
begin
  if not ClutOpenDialog.Execute then
    exit;
  CLUT2disk(true,ClutOpenDialog.filename,gCLUTrec);
  if gCLUTrec.min = gCLUTrec.max then begin
    MinEdit.value := gTexture3D.MinThreshScaled;
    MaxEdit.value := gTexture3D.MaxThreshScaled;
  end else begin
    MinEdit.value := gCLUTrec.min;
    MaxEdit.value := gCLUTrec.max;
  end;
  GLForm1.CLUTTimerXOn;
end;


initialization
{$IFDEF FPC}
  {$I clutprefs.lrs}
{$ENDIF}
end.
