unit colorbar2d;
interface
{$include options.inc}
uses
//GLBitmapFont,GLCadencer,GLContext,GLCrossPlatform,
//GLHUDObjects,GLMisc,GLObjects,GLScene,GLTexture,GLWindowsFont,
{$IFDEF FPC}GLViewer,
  {$ELSE}GLWin32Viewer,{$ENDIF}
{$IFDEF ENABLEOVERLAY}
overlay,
{$ENDIF}
{$IFDEF GLSCENEOLD}
GLMisc,
{$ELSE}
GLRenderContextInfo,
{$ENDIF}
  GLTexture,
GLWindowsFont,
OpenGL1x,GLCanvas,
clut,define_types,Math,prefs,
slices2D;

procedure DrawCLUT ( lU: TUnitRect;lBorder: single;
  var rci: TRenderContextInfo; var  lGLFont: TGLWindowsBitmapFont; lPrefs: TPrefs;
  var lGLsv: TGLSceneViewer);

implementation

procedure SetOrder (l1,l2: single; var lSmall,lLarge: single);
//set lSmall to be the lesser of l1/l2 and lLarge the greater value of L1/L2
begin
  if l1 < l2 then begin
    lSmall := l1;
    lLarge := l2;
  end else begin
    lSmall := l2;
    lLarge := l1;
  end;
end;

procedure UOffset (var lU: TUnitRect; lX,lY: single);
begin
  lU.L := lU.L+lX;
  lU.T := lU.T+lY;
  lU.R := lU.R+lX;
  lU.B := lU.B+lY;
end;

procedure DrawColorBarText(lMinIn,lMaxIn, lPGWid,lPGHt: single; lUin: TUnitRect;lBorder: single; var rci: TRenderContextInfo;
var glc: TGLCanvas; var  lGLFont: TGLWindowsBitmapFont; var lPrefs: TPrefs);
const
  kVertTextLeft = 1;
  kVertTextRight = 2;
  kHorzTextTop = 3;
  kHorzTextBottom = 4;
var
	lTextHd2,lTextH,lOrient,lDesiredSteps,lPower,lTxtWid,lTxtTop,lBarTop,lBarLeft,lBarBorder,lBarThick: integer;
  lScrnL,lScrnT,
	lMaxW,lW,lWd2,lMin,lMax,l1stStep,lRange,lStepSize,lStepPos,lBarLength: single;
	lSteps,lStep,lDecimals,lStepPosScrn: integer;
  lS: string;
  lU: TUnitRect;
begin
   lU := lUin;
   //SensibleUnitRect(lU);
   if abs(lU.R-lU.L) > abs(lU.B-lU.T) then begin //wide bars
    if (lU.B+lU.T) >1 then
      lOrient := kHorzTextBottom
    else
      lOrient := kHorzTextTop;
   end else begin //high bars
    if (lU.L+lU.R) >1 then
      lOrient := kVertTextLeft
    else
      lOrient := kVertTextRight;
   end;
	 lMin := lMinIn;
	 lMax := lMaxIn;
   if (lMinIn < 0) and (lMaxIn <= 0) then begin
	  lMin := abs(lMinIn);
	  lMax := abs(lMaxIn);
   end;
   sortsingle(lMin,lMax);
   //next: compute increment
   lDesiredSteps := 4;
   lRange := abs(lMax - lMin);
   if lRange < 0.000001 then exit;
   lStepSize := lRange / lDesiredSteps;
   lPower := 0;
   while lStepSize >= 10 do begin
      lStepSize := lStepSize/10;
	    inc(lPower);
   end;
   while lStepSize < 1 do begin
	   lStepSize := lStepSize * 10;
	   dec(lPower);
   end;
   lStepSize := round(lStepSize) *Power(10,lPower);
   if lPower < 0 then
	    lDecimals := abs(lPower)
   else
	    lDecimals := 0;

   l1stStep := trunc((lMin)  / lStepSize)*lStepSize;
   lScrnL := lU.L * lPGWid;
   lScrnT := (1-lU.B) * lPGHt;
   if lOrient =  kVertTextRight then
      lScrnL := lU.R * lPGWid;
   lTextH := lGLFont.CharHeight;
   lTextHd2 := lTextH div 2;
   if lOrient =  kHorzTextTop then
      lScrnT := ((1-lU.T) * lPGHt)-lTextH;
   if lOrient =  kHorzTextBottom then
      lScrnT := ((1-lU.B) * lPGHt);
   if l1stStep < (lMin) then l1stStep := l1stStep+lStepSize;

    lSteps := trunc( abs((lMax+0.0001)-l1stStep) / lStepSize)+1;
   //if lStepSize < 1 then
   // fx(lSteps,lStepSize);
   if (lOrient = kVertTextLeft) or (lOrient = kVertTextRight) then //vertical bars
      lBarLength := lPGHt * abs(lU.B-lU.T)
   else
      lBarLength := lPGWid * abs(lU.L-lU.R);
   lMaxW := 0;

   for lStep := 1 to lSteps do begin
      lStepPos := l1stStep+((lStep-1)*lStepSize);
      lS := realtostr(lStepPos,lDecimals);
      if (lMinIn < 0) and (lMaxIn <= 0) then
        lS := '-'+lS;
      lW := (lGLFont.CalcStringWidth(lS));
      if lW > lMaxW then
        lMaxW := lW;
   end;

   for lStep := 1 to lSteps do begin
      lStepPos := l1stStep+((lStep-1)*lStepSize);
      lStepPosScrn := round( abs(lStepPos-lMin)/lRange*lBarLength);
      lS := realtostr(lStepPos,lDecimals);
      if (lMinIn < 0) and (lMaxIn <= 0) then
        lS := '-'+lS;
      lW := lMaxW;// (GLForm1.GLWindowsBitmapFont1.CalcStringWidth(lS));
      lWd2 := round((lW+1) / 2);
      glBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
      glEnable (GL_BLEND);
      glColor4ub(lPrefs.TextBorder.rgbRed,lPrefs.TextBorder.rgbGreen,lPrefs.TextBorder.rgbBlue,lPrefs.TextBorder.rgbReserved);
        glBegin(GL_POLYGON);
      if lOrient =  kHorzTextTop then begin
        glVertex2f(lScrnL-lWd2+ lStepPosScrn,lScrnT);
        glVertex2f(lScrnL-lWd2+ lStepPosScrn,lScrnT+lTextH);
        glVertex2f(lScrnL+ lStepPosScrn,lScrnT+lTextH+(lTextH div 2));
        glVertex2f(lScrnL+lWd2+ lStepPosScrn,lScrnT+lTextH);
        glVertex2f(lScrnL+lWd2+ lStepPosScrn,lScrnT);
      end;
      if lOrient =  kHorzTextBottom then begin
        glVertex2f(lScrnL-lWd2+ lStepPosScrn,lScrnT);
        glVertex2f(lScrnL-lWd2+ lStepPosScrn,lScrnT+lTextH);
        glVertex2f(lScrnL+lWd2+ lStepPosScrn,lScrnT+lTextH);
        glVertex2f(lScrnL+lWd2+ lStepPosScrn,lScrnT);
        glVertex2f(lScrnL+ lStepPosScrn,lScrnT-(lTextH div 2));
      end;
      if (lOrient = kVertTextLeft)  then begin//vertical bars
        glVertex2f(lScrnL-lW-1,lScrnT- lStepPosScrn-lTextHd2);
        glVertex2f(lScrnL,lScrnT- lStepPosScrn-lTextHd2);
        glVertex2f(lScrnL+lTextHD2,lScrnT- lStepPosScrn);
        glVertex2f(lScrnL,lScrnT- lStepPosScrn+lTextHd2);
        glVertex2f(lScrnL-lW-1,lScrnT- lStepPosScrn+lTextHd2);
      end;
      if (lOrient = kVertTextRight)  then begin//vertical bars
        glVertex2f(lScrnL+lW+1,lScrnT- lStepPosScrn-lTextHd2);
        glVertex2f(lScrnL,lScrnT- lStepPosScrn-lTextHd2);
        glVertex2f(lScrnL-lTextHD2,lScrnT- lStepPosScrn);
        glVertex2f(lScrnL,lScrnT- lStepPosScrn+lTextHd2);
        glVertex2f(lScrnL+lW+1,lScrnT- lStepPosScrn+lTextHd2);
      end;
        glEnd;//POLYGON
        lW :=  (lGLFont.CalcStringWidth(lS));
        lWd2 := round((lW+1) / 2);
      if (lOrient = kVertTextLeft)  then //vertical bars
          lGLFont.TextOut(rci, lScrnL-lW, lScrnT - lStepPosScrn-lTextHD2, lS,RGBA2TColor(lPrefs.TextColor))
      else if (lOrient = kVertTextRight) then
          lGLFont.TextOut(rci, lScrnL+lMaxW-lW, lScrnT - lStepPosScrn-lTextHD2, lS,RGBA2TColor(lPrefs.TextColor))
      else
          lGLFont.TextOut(rci, lScrnL-lWd2 + lStepPosScrn, lScrnT, lS,RGBA2TColor(lPrefs.TextColor));
		end;
end; //DrawColorBarText

procedure DrawBorder (var lCLUT: TCLUTrec; lU: TUnitRect;lBorder: single;
  var rci: TRenderContextInfo; lPrefs: TPrefs);
var
    lL,lT,lR,lB: single;
begin
  if lBorder <= 0 then
    exit;
  SetOrder(lU.L,lU.R,lL,lR);
  SetOrder(lU.T,lU.B,lT,lB);
  go2D;
  glDisable (GL_LIGHTING);
  glBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
  if lBorder <> 0 then begin //draw border
    glEnable (GL_BLEND);
    glColor4ub(lPrefs.ColorBarBorder.rgbRed,lPrefs.ColorBarBorder.rgbGreen,lPrefs.ColorBarBorder.rgbBlue,lPrefs.ColorBarBorder.rgbReserved);
    glBegin(GL_POLYGON);
      glVertex2f(lL-lBorder,lB+lBorder);
      glVertex2f(lL-lBorder,lT-lBorder);
      glVertex2f(lR+lBorder,lT-lBorder);
      glVertex2f(lR+lBorder,lB+lBorder);
    glEnd;//POLYGON
  end; //draw border
  end2D;
end;

procedure DrawCLUTx (var lCLUT: TCLUTrec; lU: TUnitRect;
  var rci: TRenderContextInfo; lPrefs: TPrefs);
var
  lL,lT,lR,lB,lN: single;
  lI: integer;
begin
  if lCLUT.numnodes < 2 then
    exit;
  SetOrder(lU.L,lU.R,lL,lR);
  SetOrder(lU.T,lU.B,lT,lB);
  go2D;
  glDisable (GL_LIGHTING);
  glDisable (GL_BLEND);
  if (lR-lL) > (lB-lT) then begin
    lN := (lCLUT.nodes[0].intensity/255 * (lR-lL))+lL;
    for lI := 1 to (lCLUT.numnodes-1) do begin
      glBegin(GL_POLYGON);
        glColor4ub (lCLUT.nodes[lI-1].rgba.rgbRed, lCLUT.nodes[lI-1].rgba.rgbgreen,lCLUT.nodes[lI-1].rgba.rgbblue,255);
        glVertex2f(lN,lB);
        glVertex2f(lN,lT);
        lN := (lCLUT.nodes[lI].intensity/255 * (lR-lL))+lL;
        glColor4ub (lCLUT.nodes[lI].rgba.rgbRed, lCLUT.nodes[lI].rgba.rgbgreen,lCLUT.nodes[lI].rgba.rgbblue,255);
        glVertex2f(lN,lT);
        glVertex2f(lN,lB);
      glEnd;//POLYGON
    end;
  end else begin //If WIDE, else TALL
    lN := (lCLUT.nodes[0].intensity/255 * (lB-lT))+lT;
    for lI := 1 to (lCLUT.numnodes-1) do begin
      glBegin(GL_POLYGON);
        glColor4ub (lCLUT.nodes[lI-1].rgba.rgbRed, lCLUT.nodes[lI-1].rgba.rgbgreen,lCLUT.nodes[lI-1].rgba.rgbblue,255);
        glVertex2f(lL, lN);
        glVertex2f(lR, lN);
        lN := (lCLUT.nodes[lI].intensity/255 * (lB-lT))+lT;
        glColor4ub (lCLUT.nodes[lI].rgba.rgbRed, lCLUT.nodes[lI].rgba.rgbgreen,lCLUT.nodes[lI].rgba.rgbblue,255);
        glVertex2f(lR, lN);
        glVertex2f(lL, lN);
      glEnd;//POLYGON
    end;
  end;
  end2D;
end;

function BarIndex (lBarNumber: integer; IsHorzBottom: boolean): integer;
begin
  {$IFDEF ENABLEOVERLAY}
  if IsHorzBottom then
    result := gOpenOverlays - lBarNumber +1
  else
  {$ENDIF}
    result := lBarNumber;
end;//nested BarIndex

procedure SetLutFromZero(var lMin,lMax: single);
//if both min and max are positive, returns 0..max
//if both min and max are negative, returns min..0
begin
    SortSingle(lMin,lMax);
    if (lMin > 0) and (lMax > 0) then
      lMin := 0
    else if (lMin < 0) and (lMax < 0) then
      lMax := 0;
end;

procedure DrawCLUT ( lU: TUnitRect;lBorder: single;
  var rci: TRenderContextInfo; var  lGLFont: TGLWindowsBitmapFont; lPrefs: TPrefs;
  var lGLsv: TGLSceneViewer);
var
 glc: TGLCanvas;
  lU2:TUnitRect;
  lX,lY,lMin,lMax: single;
  lIsHorzTop: boolean;
  lIx,lI,lScrnWid,lScrnHt: integer;
begin
  lIsHorzTop := false;
  lScrnWid := lGLsv.Buffer.Width;
  lScrnHt := lGLsv.Buffer.Height;
{$IFDEF ENABLEOVERLAY}
  if gOpenOverlays < 1 then begin
{$ELSE}
  if true then begin
{$ENDIF}
    DrawBorder(gCLUTrec,lU,lBorder,rci,lPrefs);
    DrawCLUTx(gCLUTrec,lU,rci,lPrefs);
    if lPrefs.ColorbarText then begin
      glc:=TGLCanvas.Create(lScrnWid,lScrnHt);
      DrawColorBarText(gCLUTrec.min,gCLUTrec.max, lScrnWid,lScrnHt, lU,lBorder, rci,glc,lGLFont,lPrefs);
      glc.free;
    end;
    exit;
  end;
{$IFDEF ENABLEOVERLAY}
  if abs(lU.R-lU.L) > abs(lU.B-lU.T) then begin //wide bars
    lX := 0;
    lY := abs(lU.B-lU.T)+lBorder;
    if (lU.B+lU.T) >1 then
      lY := -lY
    else
      lIsHorzTop := true;
  end else begin //high bars
    lX := abs(lU.R-lU.L)+lBorder;
    lY := 0;
    if (lU.L+lU.R) >1 then
      lX := -lX;
  end;
  //next - draw a border - do this once for all overlays, so
  //semi-transparent regions do not display regions of overlay
  lU2 := lU;
  if gOpenOverlays > 1 then begin
    for lI := 2 to gOpenOverlays do begin
      if lX < 0 then
        lU2.L := lU2.L + lX
      else
        lU2.R := lU2.R + lX;
      if lY > 0 then
        lU2.T := lU2.T + lY
      else
        lU2.B := lU2.B + lY;
    end;
  end;
  DrawBorder(gCLUTrec,lU2,lBorder,rci,lPrefs);
  lU2 := lU;
  for lI := 1 to gOpenOverlays do begin
    DrawCLUTx(gOverlayCLUTrec[BarIndex(lI,lIsHorzTop)],lU2,rci,lPrefs);
    UOffset(lU2,lX,lY);
  end;
  if not lPrefs.ColorbarText then
    exit;
  lU2 := lU;
  glc:=TGLCanvas.Create(lScrnWid,lScrnHt);
  for lIx := 1 to gOpenOverlays do begin
    lI := BarIndex(lIx,lIsHorzTop);
    lMin := gOverlayImg[lI].WindowScaledMin;
    lMax := gOverlayImg[lI].WindowScaledMax;
    SortSingle(lMin,lMax);
    if gOverlayImg[lI].LutFromZero then
      SetLutFromZero(lMin,lMax);
    DrawColorBarText(lMin,lMax, lScrnWid,lScrnHt, lU2,lBorder, rci,glc,lGLFont,lPrefs);
    UOffset(lU2,lX,lY);
  end;
  glc.free;
{$ENDIF}
end;

end.
