unit commandsu;
{$include options.inc}
{$H+}
interface
{$IFDEF FPC}{$mode DELPHI}{$H+}{$ENDIF}

uses
{$IFDEF FPC}LResources,
{$ELSE} //Delphi
  {$IFDEF ENABLEAVI} GLAVIRecorder, {$ENDIF}
{$ENDIF}
{$IFDEF Unix} LCLIntf,{$ELSE} Windows,{$ENDIF}
   scaleimageintensity,ClipBrd, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls,   GLScene, define_types, Menus,
  uPSComponent, uPSRuntime, uPSDebugger, uPSUtils,
  uPSCompiler, uPSC_dll, uPSR_dll, uPSPreProcessor;
function OVERLAYLOAD(lFilename: string): integer; //function
function OVERLAYLOADVOL(lFilename: string; lVol: integer): integer; //function

procedure AZIMUTH (DEG: integer);
procedure AZIMUTHELEVATION (AZI, ELEV: integer);
procedure BACKCOLOR (R,G,B: byte);
procedure MODELESSCOLOR(R,G,B: byte);
procedure CAMERADISTANCE (Z: single);
procedure CHANGENODE(INDEX, INTENSITY, R,G,B,A: byte);
procedure CLIP (DEPTH: single);
procedure CLIPAZIMUTHELEVATION (DEPTH,AZI,ELEV: single);
procedure CLIPFORMVISIBLE (VISIBLE: boolean);
procedure COLORBARCOORD (L,T,R,B: single);
procedure ADDNODE(INTENSITY, R,G,B,A: byte);
procedure COLORBARFORMVISIBLE (VISIBLE: boolean);
procedure COLORBARTEXT (VISIBLE: boolean);
procedure COLORBARVISIBLE (VISIBLE: boolean);
procedure COLORNAME(Filename: string);
procedure CONTRASTFORMVISIBLE (VISIBLE: boolean);
procedure CONTRASTMINMAX(MIN,MAX: single);
procedure CUTOUT (L,A,S,R,P,I: single);
procedure CUTOUTFORMVISIBLE (VISIBLE: boolean);
procedure EDGEDETECT (lThresh: single; lDilateCycles: integer);//new
procedure MEDIANSMOOTH;//new
procedure DECIMATE (lPercent: integer);
procedure ELEVATION (DEG: integer);
procedure FRAMEVISIBLE (VISIBLE: boolean);
procedure LOADDTI(lFAFilename: string);
procedure LOADIMAGE(lFilename: string);
procedure LOADIMAGEVOL(lFilename: string; lVol: integer);
procedure MAXIMUMINTENSITY (MIP_ON: boolean);
procedure MODALMESSAGE(STR: string);
procedure MODELESSMESSAGE(STR: string);
procedure MOSAIC(Str: string);
procedure MOSAICFORMVISIBLE (VISIBLE: boolean);
procedure ORTHOVIEW (X,Y,Z: single);
procedure OVERLAYCLOSEALL;
procedure OVERLAYCOLORNAME(lOverlay: integer; lFilename: string);
procedure OVERLAYCOLORNUMBER(lOverlay,lLUTIndex: integer);
procedure OVERLAYFORMVISIBLE (VISIBLE: boolean);
procedure OVERLAYLOADSMOOTH (SMOOTH: boolean);
procedure OVERLAYCOLORFROMZERO (FROMZERO: boolean);
procedure OVERLAYMASKEDBYBACKGROUND (MASK: boolean); //new
procedure OVERLAYMINMAX (lOverlay: integer; lMin,lMax: single);
procedure OVERLAYTRANSPARENCYONBACKGROUND(lPct: integer);
procedure OVERLAYTRANSPARENCYONOVERLAY(lPct: integer);
procedure PERSPECTIVE (USEPERSPECTIVE: boolean);
procedure RESETDEFAULTS;
procedure SAVEBMP(lFilename: string);
procedure SCRIPTFORMVISIBLE (VISIBLE: boolean);
procedure SETCOLORTABLE(TABLENUM: integer);
procedure SLICETEXT (VISIBLE: boolean);
procedure LOADWATERMARK(lFilename: string; lX,lY: integer);
procedure VIDEOSTART (lFilename: string; lFPS: integer; lDefaultCodec: boolean);
procedure VIDEOCAPTUREFRAME;
procedure VIDEOEND;
procedure VIEWAXIAL (STD: boolean);
procedure VIEWCORONAL (STD: boolean);
procedure VIEWSAGITTAL (STD: boolean);
procedure WAIT(MSEC: integer);

type
  TScriptRec =  RECORD //peristimulus plot
    Ptr: Pointer;
    Decl,Vars: string[255];
  end;
const
  knFunc = 2;
  kFuncRA : array [1..knFunc] of TScriptRec =
    ( (Ptr:@OVERLAYLOAD;Decl:'OVERLAYLOAD';Vars:'(lFilename: string): integer'),
     (Ptr:@OVERLAYLOADVOL;Decl:'OVERLAYLOADVOL';Vars:'(lFilename: string; lVol: integer): integer'));
  knProc = 57;
  kProcRA : array [1..knProc] of TScriptRec =
    (
      (Ptr:@AZIMUTH;Decl:'AZIMUTH';Vars:'(DEG: integer)'),
      (Ptr:@AZIMUTHELEVATION;Decl:'AZIMUTHELEVATION';Vars:'(AZI, ELEV: integer)'),
      (Ptr:@BACKCOLOR;Decl:'BACKCOLOR';Vars:'(R, G, B: byte)'),
      (Ptr:@MODELESSCOLOR;Decl:'MODELESSCOLOR';Vars:'(R, G, B: byte)'),
      (Ptr:@CAMERADISTANCE;Decl:'CAMERADISTANCE';Vars:'(Z: single)'),
      (Ptr:@CHANGENODE;Decl:'CHANGENODE';Vars:'(INDEX, INTENSITY, R,G,B,A: byte)'),
      (Ptr:@CLIP;Decl:'CLIP';Vars:'(DEPTH: single)'),
      (Ptr:@CLIPAZIMUTHELEVATION;Decl:'CLIPAZIMUTHELEVATION';Vars:'(DEPTH,AZI,ELEV: single)'),
      (Ptr:@CLIPFORMVISIBLE;Decl:'CLIPFORMVISIBLE';Vars:'(VISIBLE: boolean)'),
      (Ptr:@COLORBARCOORD;Decl:'COLORBARCOORD';Vars:'(L,T,R,B: single)'),
      (Ptr:@ADDNODE;Decl:'ADDNODE';Vars:'(INTENSITY, R,G,B,A: byte)'),
      (Ptr:@COLORBARFORMVISIBLE;Decl:'COLORBARFORMVISIBLE';Vars:'(VISIBLE: boolean)'),
      (Ptr:@COLORBARTEXT;Decl:'COLORBARTEXT';Vars:'(VISIBLE: boolean)'),
      (Ptr:@COLORBARVISIBLE;Decl:'COLORBARVISIBLE';Vars:'(VISIBLE: boolean)'),
      (Ptr:@COLORNAME;Decl:'COLORNAME';Vars:'(Filename: string)'),
      (Ptr:@CONTRASTFORMVISIBLE;Decl:'CONTRASTFORMVISIBLE';Vars:'(VISIBLE: boolean)'),
      (Ptr:@CONTRASTMINMAX;Decl:'CONTRASTMINMAX';Vars:'(MIN, MAX: single)'),
      (Ptr:@CUTOUT;Decl:'CUTOUT';Vars:'(L,A,S,R,P,I: single)'),
      (Ptr:@CUTOUTFORMVISIBLE;Decl:'CUTOUTFORMVISIBLE';Vars:'(VISIBLE: boolean)'),
      (Ptr:@EDGEDETECT;Decl:'EDGEDETECT';Vars:'(lThresh: single; lDilateCycles: integer)'),//new
      (Ptr:@MEDIANSMOOTH;Decl:'MEDIANSMOOTH';Vars:''),
      (Ptr:@DECIMATE;Decl:'DECIMATE';Vars:'(lPercent: integer)'),
      (Ptr:@ELEVATION;Decl:'ELEVATION';Vars:'(DEG: integer)'),
      (Ptr:@FRAMEVISIBLE;Decl:'FRAMEVISIBLE';Vars:'(VISIBLE: boolean)'),
      (Ptr:@LOADDTI;Decl:'LOADDTI';Vars:'(lFAFilename: string)'),
      (Ptr:@LOADIMAGE;Decl:'LOADIMAGE';Vars:'(lFilename: string)'),
      (Ptr:@LOADIMAGEVOL;Decl:'LOADIMAGEVOL';Vars:'(lFilename: string; lVol: integer)'),
      (Ptr:@MAXIMUMINTENSITY;Decl:'MAXIMUMINTENSITY';Vars:'(MIP_ON: boolean)'),
      (Ptr:@MODALMESSAGE;Decl:'MODALMESSAGE';Vars:'(STR: string)'),
      (Ptr:@MODELESSMESSAGE;Decl:'MODELESSMESSAGE';Vars:'(STR: string)'),
      (Ptr:@MOSAIC;Decl:'MOSAIC';Vars:'(Str: string)'),
      (Ptr:@MOSAICFORMVISIBLE;Decl:'MOSAICFORMVISIBLE';Vars:'(VISIBLE: boolean)'),
      (Ptr:@ORTHOVIEW;Decl:'ORTHOVIEW';Vars:'(X,Y,Z: single)'),
      (Ptr:@OVERLAYCLOSEALL;Decl:'OVERLAYCLOSEALL';Vars:''),
      (Ptr:@OVERLAYCOLORNAME;Decl:'OVERLAYCOLORNAME';Vars:'(lOverlay: integer; lFilename: string)'),
      (Ptr:@OVERLAYCOLORNUMBER;Decl:'OVERLAYCOLORNUMBER';Vars:'(lOverlay, lLUTIndex: integer)'),
      (Ptr:@OVERLAYFORMVISIBLE;Decl:'OVERLAYFORMVISIBLE';Vars:'(VISIBLE: boolean)'),
      (Ptr:@OVERLAYLOADSMOOTH;Decl:'OVERLAYLOADSMOOTH';Vars:'(SMOOTH: boolean)'),
      (Ptr:@OVERLAYCOLORFROMZERO;Decl:'OVERLAYCOLORFROMZERO';Vars:'(FROMZERO: boolean)'),
      (Ptr:@OVERLAYMASKEDBYBACKGROUND;Decl:'OVERLAYMASKEDBYBACKGROUND';Vars:'(MASK: boolean)'), //new
      (Ptr:@OVERLAYMINMAX;Decl:'OVERLAYMINMAX';Vars:'(lOverlay: integer; lMin,lMax: single)'),
      (Ptr:@OVERLAYTRANSPARENCYONBACKGROUND;Decl:'OVERLAYTRANSPARENCYONBACKGROUND';Vars:'(lPct: integer)'),
      (Ptr:@OVERLAYTRANSPARENCYONOVERLAY;Decl:'OVERLAYTRANSPARENCYONOVERLAY';Vars:'(lPct: integer)'),
      (Ptr:@PERSPECTIVE;Decl:'PERSPECTIVE';Vars:'(USEPERSPECTIVE: boolean)'),
      (Ptr:@RESETDEFAULTS;Decl:'RESETDEFAULTS';Vars:''),
      (Ptr:@SAVEBMP;Decl:'SAVEBMP';Vars:'(lFilename: string)'),
      (Ptr:@SCRIPTFORMVISIBLE;Decl:'SCRIPTFORMVISIBLE';Vars:'(VISIBLE: boolean)'),
      (Ptr:@SETCOLORTABLE;Decl:'SETCOLORTABLE';Vars:'(TABLENUM: integer)'),
      (Ptr:@SLICETEXT;Decl:'SLICETEXT';Vars:'(VISIBLE: boolean)'),
      (Ptr:@LOADWATERMARK;Decl:'LOADWATERMARK';Vars:'(lFilename: string; lX,lY: integer)'),
      (Ptr:@VIDEOSTART;Decl:'VIDEOSTART';Vars:'(lFilename: string; lFPS: integer; lDefaultCodec: boolean)'),
      (Ptr:@VIDEOCAPTUREFRAME;Decl:'VIDEOCAPTUREFRAME';Vars:''),
      (Ptr:@VIDEOEND;Decl:'VIDEOEND';Vars:''),
      (Ptr:@VIEWAXIAL;Decl:'VIEWAXIAL';Vars:'(STD: boolean)'),
      (Ptr:@VIEWCORONAL;Decl:'VIEWCORONAL';Vars:'(STD: boolean)'),
      (Ptr:@VIEWSAGITTAL;Decl:'VIEWSAGITTAL';Vars:'(STD: boolean)'),
      (Ptr:@WAIT;Decl:'WAIT';Vars:'(MSEC: integer)')
    );

implementation
uses
    mainunit,userdir,prefs,clut,messageu
    {$IFDEF ENABLECLUT}, clutprefs  {$ENDIF}
    {$IFDEF ENABLEOVERLAY}, overlay {$ENDIF}
    {$IFDEF ENABLECOLORBAR},colorbar {$ENDIF}
    {$IFDEF ENABLECLIP}, mosaicprefs {$ENDIF}
    {$IFDEF ENABLECLIP}, clipu {$ENDIF}
  {$IFDEF ENABLECUTOUT}, cutoutu {$ENDIF}
  {$IFDEF ENABLESCRIPT}, scriptengine{$ENDIF};
{$IFDEF FPC}
var
  gAVIname : string = '';
  gAVIFrame : integer = 0;
{$ELSE} //if FPC else Delphi
  {$IFNDEF ENABLEAVI}
  var
    gAVIname : string = '';
    gAVIFrame : integer = 0;
  {$ENDIF} //if not enableAVE
{$ENDIF} //Delphi


procedure FinishRender;
begin
    repeat
      application.ProcessMessages;
      //application.HandleMessage;
    until (not gRendering) and (not GLForm1.Timer.Enabled) and (not GLForm1.UpdateTimer.Enabled);
end;

procedure view3D;
begin
  if gPrefs.OrthoSliceView then
    FinishRender;
  {$IFDEF Darwin}
   GLForm1.M_Refresh := TRUE;
   GLForm1.GLSceneViewer1.invalidate;
   GLForm1.SetView(false,false);
   {$ELSE}
   GLForm1.M_Refresh := TRUE;
   GLForm1.GLSceneViewer1.invalidate;
 GLForm1.SetView(false,true);
 {$ENDIF}
 //GLForm1.OrthoSliceViewMenuClick(nil);
end;

procedure WAIT (MSEC: integer);
var
lEND : DWord;
begin
  lEND := GetTickCount+MSEC;
  FinishRender;//June 09
  repeat
    Application.ProcessMessages;//HandleMessage
  until GetTickCount >= lEnd;
end;

procedure view2D;
begin
//if not gPrefs.OrthoSliceView then
  FinishRender;
  {$IFDEF Darwin}
GLForm1.SetView(true,false);
{$ELSE}
   GLForm1.M_Refresh := TRUE;
   GLForm1.GLSceneViewer1.invalidate;
 GLForm1.SetView(true,true);
{$ENDIF}
end;

procedure viewXD;
begin
{$IFDEF Darwin}
GLForm1.SetView(gPrefs.OrthoSliceView,false);
{$ELSE}
 GLForm1.SetView(gPrefs.OrthoSliceView,true);
{$ENDIF}
end;

procedure RESETDEFAULTS;
begin
  FinishRender;
  SetDefaultPrefs(gPrefs,false);
  GLForm1.DisplayPrefs(gPrefs);
end;

function OVERLAYLOAD(lFilename: string): integer;
begin
  {$IFDEF ENABLEOVERLAY}
  result := OverlayForm.AddOverlay(lFilename,1);
  {$ENDIF}
end;

function OVERLAYLOADVOL(lFilename: string; lVol: integer): integer;
begin
  {$IFDEF ENABLEOVERLAY}
  result := OverlayForm.AddOverlay(lFilename,lVol);
  {$ENDIF}
end;

function ChangeEnd (lInStr,lNewEnd: string): string;
// filename_FA,V1 will return Filename_V1
var
  lLenStr,lLenEnd,lI: integer;
begin
  result := '';
  lLenStr:= length(lInStr);
  lLenEnd := length(lNewEnd);
  if lLenStr < lLenEnd then
    exit;
  result := lInStr;
  if lLenEnd < 1 then
    exit;
  for lI := 1 to lLenEnd do
    result[lLenStr-lLenEnd+lI] := lNewEnd[lI];
end;

procedure LOADIMAGEVOL(lFilename: string; lVol: integer);
begin
  FinishRender;
    GLForm1.LoadDatasetNIFTIVol(lFileName,false,lVol);
end;

procedure LOADIMAGE(lFilename: string); 
begin
  FinishRender;
    GLForm1.LoadDatasetNIFTIvol1(lFileName,false);
end;

procedure LOADDTI(lFAFilename: string);
var
  lPath,lName,lExt,lV1: string;
begin
  GLForm1.LoadDatasetNIFTIvol1(lFAFilename,false);
  FilenameParts (gPrefs.PrevFilename[1]{lFAFilename}, lPath,lName,lExt);
  lV1 := ChangeEnd (lPath+lName,'V1')+lExt;
  if not Fileexists(lV1) then
    showmessage('Unable to find FSL vector named '+lV1);
  {$IFDEF ENABLEOVERLAY}
  OverlayForm.Addoverlay(lV1,1);
  OverlayForm.Addoverlay(lV1,2);
  OverlayForm.Addoverlay(lV1,3);
  AbsImgIntensity32(gOverlayImg[1] );
  AbsImgIntensity32(gOverlayImg[2] );
  AbsImgIntensity32(gOverlayImg[3] );
  OverlayForm.UpdateImageIntensityMinMax (1, 0,1);
  OverlayForm.UpdateImageIntensityMinMax (2, 0,1);
  OverlayForm.UpdateImageIntensityMinMax (3, 0,1);
  OVERLAYTRANSPARENCYONBACKGROUND(-2);//modulate
  OVERLAYTRANSPARENCYONOVERLAY(-1);//additive
  {$ENDIF}
end;

procedure OVERLAYCLOSEALL;
begin
  {$IFDEF ENABLEOVERLAY}
  OverlayForm.Closeoverlays1Click(nil);
  {$ENDIF}
end;

procedure OVERLAYCOLORNUMBER(lOverlay,lLUTIndex: integer);
begin
  {$IFDEF ENABLEOVERLAY}
  OverlayForm.UpdateLUT(lOverlay,lLUTIndex,true);
  OverlayForm.ChangeOverlayUpdate;
  {$ENDIF}
end;

procedure OVERLAYCOLORNAME(lOverlay: integer; lFilename: string);
var
  lLUTIndex: integer;
begin
  {$IFDEF ENABLEOVERLAY}
  SetItemNameX (lFilename, OverlayForm.LUTDrop);
  lLUTIndex :=  OverlayForm.LUTDrop.ItemIndex;
  OverlayForm.UpdateLUT(lOverlay,lLUTIndex,true);
  OverlayForm.ChangeOverlayUpdate;
  {$ENDIF}
end;

procedure OVERLAYMINMAX (lOverlay: integer; lMin,lMax: single);
begin
  {$IFDEF ENABLEOVERLAY}
OverlayForm.UpdateImageIntensityMinMax (lOverlay, lMin,lMax);
  {$ENDIF}
end;

procedure OVERLAYTRANSPARENCYONBACKGROUND(lPct: integer);
begin
  {$IFDEF ENABLEOVERLAY}
  gPrefs.BackgroundAlpha := lPct;
  OverlayForm.StatusPanelUpdate;
  OverlayForm.ChangeOverlayUpdate;
  OverlayForm.SetSubmenuWithTag(OverlayForm.Onbackground1,gPrefs.BackgroundAlpha);
  {$ENDIF}
end;

procedure OVERLAYTRANSPARENCYONOVERLAY(lPct: integer);
begin
  {$IFDEF ENABLEOVERLAY}
  gPrefs.OverlayAlpha := lPct;
  OverlayForm.StatusPanelUpdate;
  OverlayForm.ChangeOverlayUpdate;
  OverlayForm.SetSubmenuWithTag(OverlayForm.Onotheroverlays1,gPrefs.OverlayAlpha);
  {$ENDIF}
end;

procedure OVERLAYLOADSMOOTH (SMOOTH: boolean);
begin
  {$IFDEF ENABLEOVERLAY}
  gPrefs.InterpolateOverlays := SMOOTH;
  OverlayForm.InterpolateMenu.Checked := SMOOTH;
  {$ENDIF}
end;

procedure OVERLAYMASKEDBYBACKGROUND (MASK: boolean);
begin
  {$IFDEF ENABLEOVERLAY}
    gPrefs.MaskOverlayWithBackground := Mask;
    OverlayForm.BackgroundMaskMenu.Checked := Mask;
    {$ENDIF}
end;

procedure OVERLAYCOLORFROMZERO (FROMZERO: boolean);
begin
  {$IFDEF ENABLEOVERLAY}
  gPrefs.OverlayColorFromZero := FROMZERO;
    OverlayForm.OverlayColorFromZeroMenu.Checked := FROMZERO;
    OverlayForm.OverlayColorFromZeroMenuClick(nil);
    {$ENDIF}
end;

procedure MOSAIC(Str: string);
begin
    GLForm1.DrawMosaic(Str);
end;

procedure MESSAGEX(STR: string);
begin
    MessageForm.CaptionLabel.Caption := Str;
    MessageForm.showmodal;
    repeat
        application.HandleMessage;
    until MessageForm.ModalResult = mrOK;
end;


procedure MODALMESSAGE(STR: string);
begin
  MESSAGEX(STR);
end;

procedure MODELESSCOLOR (R,G,B: byte);
begin
  GLForm1.GLHUDText1.modulatecolor.red := R/255;
  GLForm1.GLHUDText1.modulatecolor.green := G/255;
  GLForm1.GLHUDText1.modulatecolor.blue := B/255;
  //GLForm1.GLSceneViewer1.Buffer.BackgroundColor :=  gPrefs.BackgroundColor;
  viewXD;
end;

procedure MODELESSMESSAGE(STR: string);
begin
    GLForm1.GLHUDText1.text := (STR);
end;

procedure SLICETEXT (VISIBLE: boolean);
begin
  gPrefs.SLICEText := VISIBLE;
  GLForm1.UpdateTimer.enabled := true;
end;

procedure COLORBARTEXT (VISIBLE: boolean);
begin
  gPrefs.ColorBarText := VISIBLE;
  GLForm1.UpdateTimer.enabled := true;
end;

procedure COLORBARVISIBLE (VISIBLE: boolean);
begin
  gPrefs.ColorBar := VISIBLE;
  GLForm1.UpdateTimer.enabled := true;
end;

procedure COLORBARCOORD (L,T,R,B: single);
begin
  gPrefs.ColorBarPos:= CreateUnitRect (L,T,R,B);
  SensibleUnitRect(gPrefs.ColorBarPos);
  GLForm1.UpdateTimer.Enabled := true;
end;

procedure MEDIANSMOOTH;
begin
  GLForm1.MedianSmoothing;
  {$IFDEF Darwin}
  view3D;
  {$ENDIF}
end;

procedure EDGEDETECT (lThresh: single; lDilateCycles: integer);
begin
  GLForm1.EdgedetectionX(lThresh,lDilateCycles);
  {$IFDEF Darwin}
  view3D;
  {$ENDIF}
end;

procedure DECIMATE (lPercent: integer);
begin
  GLForm1.DecimateV(lPercent);
  {$IFDEF Darwin}
  view3D;
  {$ENDIF}
end;

procedure OVERLAYFORMVISIBLE (VISIBLE: boolean);
begin
  {$IFDEF ENABLEMOSAIC}
  GLForm1.Overlays1Click(nil);
  OverlayForm.visible := VISIBLE;
  {$ENDIF}
end;

procedure SCRIPTFORMVISIBLE (VISIBLE: boolean);
begin
  {$IFDEF ENABLESCRIPT}
  GLForm1.Scripting1Click(nil);
  ScriptForm.visible := VISIBLE;
  {$ENDIF}
end;

procedure CONTRASTFORMVISIBLE (VISIBLE: boolean);
begin
  {$IFDEF ENABLECLUT}
  GLFOrm1.Colorandtransarency1Click(nil);
  CLUTForm.visible := VISIBLE;
  {$ENDIF}
end;

procedure COLORBARFORMVISIBLE (VISIBLE: boolean);
begin
  {$IFDEF ENABLECOLORBAR}
  GLFOrm1.ColorbarFormMenuClick(nil);
  ColorbarForm.visible := VISIBLE;
  {$ENDIF}
end;

procedure CUTOUTFORMVISIBLE (VISIBLE: boolean);
begin
  {$IFDEF ENABLECUTOUT}
  GLForm1.AdjustFormPos(TFOrm(CutOutForm));
  CutOutForm.visible := VISIBLE;
  {$ENDIF}
end;

procedure CLIPFORMVISIBLE (VISIBLE: boolean);
begin
  {$IFDEF ENABLECLIP}
  GLForm1.AdjustFormPos(TFOrm(CLIPForm));
  CLIPForm.visible := VISIBLE;
  {$ENDIF}
end;

procedure MOSAICFORMVISIBLE (VISIBLE: boolean);
begin
    {$IFDEF ENABLEMOSAIC}
  MosaicPrefsForm.visible := VISIBLE;
    {$ENDIF}
end;

procedure ELEVATION (DEG: integer);
begin
  view3D;
  GLForm1.GLCamera1.MoveAroundTarget (DEG,0);
end;

procedure AZIMUTHELEVATION (AZI, ELEV: integer);
begin
  view3D;
  GLForm1.Camera2AzimuthElevationDeg(AZI,ELEV);
end;

procedure CAMERADISTANCE (Z: single);
begin
  GLForm1.ViewingDistance(Z);
end;

procedure COLORNAME(Filename: string);
begin
  SetItemNameX (Filename, CLUTForm.LUTDrop);
  CLUTFOrm.LUTDropChange (nil);
end;

procedure SETCOLORTABLE(TABLENUM: integer);
begin
  CLUTForm.LUTDrop.ItemIndex := TABLENUM;
  CLUTFOrm.LUTDropChange (nil);
end;

procedure RenderUpdate;
begin
   CLUTForm.DrawCLUTa(gCLUTrec);
   GLForm1.M_Refresh := TRUE;
   GLForm1.GLSceneViewer1.invalidate;
end;

procedure CHANGENODE(INDEX, INTENSITY, R,G,B,A: byte);
var
  lNode,lI: integer;
begin
  lNode := INDEX;
  if lNode < 0 then
    lNode := 0;
  if lNode > (gCLUTrec.numnodes-1) then
    lNode := gCLUTrec.numnodes-1;
  lI := INTENSITY;
  //window spans from zero to 255, so bounding nodes must be in this range....
  if lNode = 0 then
    lI := 0;
  if lNode = (gCLUTrec.numnodes-1) then
    lI := 255;
  //we need to keep the nodes in order...
  if (lNode > 0) and (lI <= gCLUTrec.nodes[lNode-1].intensity) then
    lI := gCLUTrec.nodes[lNode-1].intensity + 1;
  if (lNode < (gCLUTrec.numnodes-1)) and (lI >= gCLUTrec.nodes[lNode+1].intensity) then
    lI := gCLUTrec.nodes[lNode-1].intensity - 1;
  gCLUTrec.nodes[lNode].intensity := lI;
  gCLUTrec.nodes[lNode].rgba := RGBA(R,G,B,A);
  //gCLUTrec.nodes[lNode] := node(lI, R,G,B,A); //<-1/2010 on x86-64, pascalscript requires previous two lines...
  RenderUpdate;
end;

procedure ADDNODE(INTENSITY, R,G,B,A: byte);
var
  lNode: integer;
begin
  lNode := CLUTForm.AddColorNode(Intensity);
  if lNode < 0 then
    exit;
  CHANGENODE(lNode, INTENSITY, R,G,B,A);
end;

procedure CONTRASTMINMAX(MIN,MAX: single);
var
 x,n: single;
begin
     if MIN < Max then begin
        n := MIN;
        x := MAX;
     end else begin
         n := MAX;
         x := MIN;
     end;
          gCLUTrec.min := n;
        gCLUTrec.max := x;
   CLUTform.MinMax(n,x);
    RenderUpdate;
end;

procedure CLIP (DEPTH: single);
begin
    {$IFDEF ENABLECLIP}
  GLForm1.SetViewerClipPlane(round(Depth * ClipForm.ClipTrack.Max));
    {$ENDIF}
end;

procedure CLIPAZIMUTHELEVATION (DEPTH,AZI,ELEV: single);
begin
//showmessage( floattostr(DEPTH)+' '+floattostr(Azi)+'  '+floattostr(Elev));
    {$IFDEF ENABLECLIP}
    GLForm1.SetViewerClipPlaneAE (round(Depth * ClipForm.ClipTrack.Max),round(AZI),round(Elev));
    {$ENDIF}
end;

procedure ORTHOVIEW (X,Y,Z: single);
begin
  gOrthoX := X;
  gOrthoY := Y;
  gOrthoZ := Z;
 view2D;
end;

procedure BACKCOLOR (R,G,B: byte);
begin
  gPrefs.BackgroundColor :=R+ G shl 8 + B shl 16;
  GLForm1.GLSceneViewer1.Buffer.BackgroundColor :=  gPrefs.BackgroundColor;
  viewXD;
end;

procedure CUTOUT (L,A,S,R,P,I: single);
var
  lMax: integer;
begin
    {$IFDEF ENABLECUTOUT}
  lMax := CutoutForm.XTrackBar.Max;
  CutoutForm.XTrackBar.Position := round(L*lMax);
  CutoutForm.X2TrackBar.Position := round(R*lMax);
  CutoutForm.YTrackBar.Position := round(A*lMax);
  CutoutForm.Y2TrackBar.Position := round(P*lMax);
  CutoutForm.ZTrackBar.Position := round(S*lMax);
  CutoutForm.Z2TrackBar.Position := round(I*lMax);
  view3D;
  {$ENDIF}
end;

procedure MAXIMUMINTENSITY (MIP_ON: boolean);
begin
  GLForm1.MIPMenu.Checked := MIP_ON;
  GLForm1.MIPChange(nil);
  view3D;
end;

procedure VIEWAXIAL (STD: boolean);
begin
  if STD then
    GLForm1.Axial1Click(nil)
  else
    GLForm1.Axial2Click(nil);
  view3D;
end;

procedure VIEWCORONAL (STD: boolean);
begin
  if STD then
   GLForm1.Coronal1Click(nil)
  else
   GLForm1.Coronal2Click(nil);
  view3D;
end;

procedure VIEWSAGITTAL (STD: boolean);
begin
  if STD then
   GLForm1.Sagittal1Click(nil)
  else
   GLForm1.Sagittal2Click(nil);
  view3D;
end;

procedure PERSPECTIVE (USEPERSPECTIVE: boolean);
begin
  GLForm1.PerspectiveMenu.checked := USEPERSPECTIVE;
  GLForm1.PerspectiveMenuClick(nil);
end;

procedure FRAMEVISIBLE (VISIBLE: boolean);
begin
  GLForm1.Frame.Visible := VISIBLE;
  GLForm1.FrameMenu.Checked := VISIBLE;
  view3D;
end;

procedure LOADWATERMARK(lFilename: string; lX,lY: integer);
//LOADWATERMARK('C:\pas\mricrogl\source\watermark.bmp',72,290);
var
  lFilenameX:string;
begin
   lFilenameX := lFilename;
   if lFilenameX = '' then begin
    GLForm1.GLwatermark.visible := false;
    exit;
   end;
   GLForm1.CheckFilename (lFilenameX,true);
   if not fileexists(lFilenameX) then begin
    showmessage('Can''t find '+lFilenameX);
    exit;
   end;
   GLForm1.GLwatermark.Position.X:=lX;
   GLForm1.GLwatermark.Position.Y:=lY;
    GLForm1.GLwatermark.visible := true;
    with GLForm1.GLMaterialLibrary1.Materials[0] do  begin
      Material.Texture.Disabled := false;
      Material.Texture.Image.LoadFromFile(lFilenameX);
  GLForm1.GLwatermark.Width := Material.Texture.Image.Width;
  GLForm1.GLwatermark.Height := Material.Texture.Image.Height;
    end;

end;

procedure VIDEOSTART (lFilename: string; lFPS: integer; lDefaultCodec: boolean);
var
  lF: string;
begin
  VIDEOEND;//save any previous recording
  {$IFDEF FPC}
     gAVIname := lFilename;
   gAVIFrame := 0;
  {$ELSE} //if FPC else Delphi
  {$IFDEF ENABLEAVI}
  if lFPS < 0 then begin
    GLForm1.AVIRecorder1.FPS := 0;
    GLForm1.AVIRecorder1.Tag := 0;
    GLForm1.AVIRecorder1.Filename := lFilename;
    exit;
  end else if lFPS > 0 then
    GLForm1.AVIRecorder1.FPS := lFPS
  else
    GLForm1.AVIRecorder1.FPS := 20;

  GLForm1.AVIRecorder1.Height := GLForm1.GLSceneViewer1.Height;
  GLForm1.AVIRecorder1.Width := GLForm1.GLSceneViewer1.Width;
  if lDefaultCodec then
    GLForm1.AVIRecorder1.compressor :=  acDefault
  else
    GLForm1.AVIRecorder1.compressor := acShowDialog;
  lF := lFilename;
  if UpCaseExt(lF) <> '.AVI'  then
        lF := lF + '.avi';
  EnsureDirExists(lF);
  GLForm1.AVIRecorder1.Filename := lF;
  GLForm1.AVIRecorder1.Tag := 0;
  if not GLForm1.AVIRecorder1.CreateAVIFile then Exit;
  {$ELSE} //save bitmaps not AVI
   gAVIname := lFilename;
   gAVIFrame := 0;
  {$ENDIF}
 {$ENDIF}
end;


procedure VIDEOCAPTUREFRAME;
var
  lFrame: integer;
  lExt,lF: string;
begin
  {$IFNDEF FPC}
     {$IFDEF ENABLEAVI}
     if GLForm1.AVIRecorder1.FPS > 0 then begin //save video...
       if not GLForm1.AVIRecorder1.Recording then
         exit;
       FinishRender;
       GLForm1.AVIRecorder1.AddAVIFrame;
       GLForm1.AVIRecorder1.Tag := GLForm1.AVIRecorder1.Tag+1;
       exit;
     end else begin //save every still image...
         lF := GLForm1.AVIRecorder1.Filename;
         if (lF = '') then
            exit;
         GLForm1.AVIRecorder1.Tag := GLForm1.AVIRecorder1.Tag+1;
         lFrame := GLForm1.AVIRecorder1.Tag;
     end;
    {$ELSE} //save bitmaps not AVI
    if (gAVIname = '') then
      exit;
    lF := gAVIname;
    inc(gAVIFrame);
    lFrame := gAVIFrame;
    {$ENDIF}//AVI
 {$ELSE} //IF DELPHI ELSE FPC...
 if (gAVIname = '') then
  exit;
 lF := gAVIname;
 inc(gAVIFrame);
 lFrame := gAVIFrame;
 {$ENDIF}
   lExt := UpCaseExt(lF);
  if (lExt <> '.JPG') and (lExt <> '.PNG')  then
        lF := lF + '.png';
  EnsureDirExists(lF);
  lF := ChangeFilePostfix(lF,PadStr(lFrame,4));
  FinishRender;
  GLForm1.SavePicture(lF);
end;

procedure VIDEOEND;
begin
  {$IFDEF FPC}
   gAVIname := '';
  {$ELSE} //if FPC ELSE Delphi
  {$IFDEF ENABLEAVI}

  if GLForm1.AVIRecorder1.FPS = 0 then begin //save still images as PNG/JPG...
    GLForm1.AVIRecorder1.Filename := '';
    GLForm1.AVIRecorder1.Tag := 0;
    exit;
  end;
  if not GLForm1.AVIRecorder1.Recording then begin
    GLForm1.AVIRecorder1.Tag := 0;
    exit;
  end;
  if GLForm1.AVIRecorder1.Tag < 1 then //no video
    GLForm1.AVIRecorder1.CloseAVIFile(true{UserAbort})
  else
    GLForm1.AVIRecorder1.CloseAVIFile(false{UserAbort});
  GLForm1.AVIRecorder1.Tag := 0;
  {$ELSE}
   gAVIname := '';
  {$ENDIF}
 {$ENDIF}
end;



procedure AZIMUTH (DEG: integer);
begin
  view3D;
  GLForm1.GLCamera1.MoveAroundTarget (0,DEG);
end;

procedure SAVEBMP(lFilename: string);
var
  lF,lExt: string;
begin
  FinishRender;
  lF := lFilename;
  //showmessage(lFilename);
  //exit;
  lExt := UpCaseExt(lF);
  if (lExt <> '.JPG') and (lExt <> '.PNG')  then
        lF := lF + '.png';
  EnsureDirExists(lF);
  GLForm1.SavePicture(lF);
end;

end.
