unit lut;

interface
uses define_types, sysutils, dialogs, clut;

const
 knAutoLUT = 7;
procedure LUTdropLoad( lLUTindex: integer; var lLUT: TLUT; lLUTname: string; var lCLUTrec: TCLUTrec);
//procedure LoadColorScheme(lStr: string; var lLUT: TLUT);

implementation

(*function ColorSchemeDir: string;
begin
  result := extractfilepath(paramstr(0))+'lut'
end; *)

(*procedure LoadColorScheme(lStr: string; var lLUT: TLUT);
const UNIXeoln = chr(10);
var
   lF: textfile;
   lBuff: bytep0;
   lFData: file;
   lCh: char;
   lNumStr: String;
   lZ : integer;
   lByte,lIndex: byte;
   //lType,
   lIndx,lLong,lR,lG: boolean;
procedure ResetBools; //nested
begin
	//lType := false;
	lIndx := false;
	lR := false;
	lG := false;
	lNumStr := '';
end; //nested proc ResetBools
begin //proc LoadColorScheme
	 if not fileexistsex(lStr) then exit;
	 lZ := FSize(lStr);
	 if (lZ =768) or (lZ = 800) or (lZ=970) then begin
		//binary LUT
		assignfile(lFdata,lStr);
		Filemode := 0;
		reset(lFdata,1);
		seek(lFData,lZ-768);
		GetMem( lBuff, 768);
		BlockRead(lFdata, lBuff^, 768);
		for lZ := 0 to 255 do begin
			lLUT[lZ].rgbRed := lBuff^[lZ];
			lLUT[lZ].rgbGreen := lBuff^[lZ+256];
			lLUT[lZ].rgbBlue := lBuff^[lZ+512];
			lLUT[lZ].rgbReserved := kLUTalpha;
		end;
		closefile(lFdata);
		Filemode := 2;
		freemem(lBuff);
		exit;
	 end;
	 //Text LUT
	 assignfile(lF,lStr);
	 Filemode := 0;
	 reset(lF);
     lLong := false;
     lIndex := 0;
     ResetBools;
	 for lZ := 0 to 255 do begin
		 lLUT[lZ].rgbRed := 0;
		 lLUT[lZ].rgbGreen := 0;
		 lLUT[lZ].rgbBlue := 0;
		 lLUT[lZ].rgbReserved := kLUTalpha;
	 end;
     while not EOF(lF) do begin
         read(lF,lCh);
         if lCh = '*' then //comment character
            while (not EOF(lF)) and (lCh <> kCR) and (lCh <> UNIXeoln) do
                  read(lF,lCh);
         if (lCh = 'L') or (lCh = 'l') then begin
            //lType := true;
            lLong := true;
         end; //'l'
         if (lCh = 's') or (lCh = 'S') then begin
            //lType := true;
            lLong := false;
         end; //'s'
		 if lCh in ['0'..'9'] then
             lNumStr := lNumStr + lCh;
         if ((not(lCh in ['0'..'9'])) or (EOF(lF)) ) and (length(lNumStr) > 0) then begin //not a number = space??? try to read number string
              if not lIndx then begin
                 lIndex := strtoint(lNumStr);
                 lIndx := true;
              end else begin //not index
                  if lLong then
                     lByte := trunc(strtoint(lNumStr) / 256)
                  else
                      lByte := strtoint(lNumStr);
		  if not lR then begin
		     lLUT[lIndex].rgbRed := lByte;
                     lR := true;
                  end else if not lG then begin
                      lLUT[lIndex].rgbGreen := lByte;
                      lG := true;
                  end else {final value is blue} begin
                      lLUT[lIndex].rgbBlue := lByte;
                      ResetBools;
                  end;
              end;
              lNumStr := '';
         end;
     end; //not eof
     CloseFile(lF);
	 Filemode := 2;
end; //Proc LoadColorScheme  *)

procedure LinearMinMaxCLUTrec(lMin,lMax: TGLRGBQuad; var lNodeRA: TCLUTrec);
//creates linear RGBA values from minimum to maximum
begin
  lNodeRA.nodes[0].intensity := 0;
  lNodeRA.nodes[0].rgba := lMin;
  lNodeRA.nodes[1].intensity := 255;
  lNodeRA.nodes[1].rgba := lMax;
  lNodeRA.numnodes := 2;
end;

procedure  LoadMonochromeLUT (var lLUTindex: integer; var lLUT: TLUT; var lCLUTrec: TCLUTrec); //lLUT: 0=gray,1=red,2=green,3=blue
var
   //lR,lG,lB,
   lInc: integer;
begin
	case lLUTindex of
		1:
		for lInc := 0 to 255 do begin
		 lLUT[lInc].rgbRed := lInc;
		 lLUT[lInc].rgbGreen := 0;
		 lLUT[lInc].rgbBlue := 0;
		 lLUT[lInc].rgbReserved := kLUTalpha;
		end;//red
		2:
		for lInc := 0 to 255 do begin
		 lLUT[lInc].rgbRed := 0;
		 lLUT[lInc].rgbGreen := lInc;
		 lLUT[lInc].rgbBlue := 0;
		 lLUT[lInc].rgbReserved := kLUTalpha;
		end;//green
		3:
		for lInc := 0 to 255 do begin
		 lLUT[lInc].rgbRed := 0;
		 lLUT[lInc].rgbGreen := 0;
		 lLUT[lInc].rgbBlue := lInc;
		 lLUT[lInc].rgbReserved := kLUTalpha;
		end;//blue
    		4:
		for lInc := 0 to 255 do begin
		 lLUT[lInc].rgbRed := lInc;
		 lLUT[lInc].rgbGreen := 0;
		 lLUT[lInc].rgbBlue := lInc;
		 lLUT[lInc].rgbReserved := kLUTalpha;
		end;//r+b=violet
		5:
		for lInc := 0 to 255 do begin
		 lLUT[lInc].rgbRed := lInc;
		 lLUT[lInc].rgbGreen := lInc;
		 lLUT[lInc].rgbBlue := 0;
		 lLUT[lInc].rgbReserved := kLUTalpha;
		end;//red + green = yellow
		6:
		for lInc := 0 to 255 do begin
		 lLUT[lInc].rgbRed := 0;
		 lLUT[lInc].rgbGreen := lInc;
		 lLUT[lInc].rgbBlue := lINc;
		 lLUT[lInc].rgbReserved := kLUTalpha;
		end;//green+blue = cyan

		else begin
			for lInc := 0 to 255 do begin
				lLUT[lInc].rgbRed := lInc;
				lLUT[lInc].rgbGreen := lInc;
				lLUT[lInc].rgbBlue := lInc;
				lLUT[lInc].rgbReserved := kLUTalpha;
			end;//for gray
		end//else... gray
	end;
  LinearMinMaxCLUTrec(lLUT[0],lLUT[255],lCLUTrec);
end;


procedure LUTdropLoad(lLUTindex: integer; var lLUT: TLUT; lLUTname: string; var lCLUTrec: TCLUTrec);
var
   lStr: string;
begin
	 //if gMRIcroOverlay[lLayer].UsesCustomPalette then
	 //	exit;
	 if lLUTindex < knAutoLUT then begin
    LoadMonochromeLUT(lLUTindex,lLUT,lCLUTrec);
		exit;
	 end; //if B&W lut
   lStr := ClutDir+pathdelim+lLUTname+'.clut';
	 if not FileExistsEX(lStr) then  begin
		showmessage('Can not find '+lStr);
    exit;
   end;     

   CLUT2TLUT(lStr,lLUT,lCLUTrec);
	 (*lStr := ClutDir+pathdelim+lLUTname+'.lut';
	 if not FileExistsEX(lStr) then  begin
		showmessage('Can not find '+lStr);
    exit;
   end;
	 LoadColorScheme(lStr, lLUT); *)
end;

end.
 