unit scriptengine;
{$include options.inc}
{$H+}
interface
{$IFDEF FPC}{$mode DELPHI}{$H+}{$ENDIF}
uses
{$IFDEF FPC}LResources,
{$ENDIF}
{$IFDEF Unix} LCLIntf,{$ELSE} Windows,Messages, {$ENDIF}
   scaleimageintensity,ClipBrd, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls,   GLScene, define_types, Menus,
  uPSComponent,commandsu;
type
  { TScriptForm }
  TScriptForm = class(TForm)
    //azimuthelevantion1: TMenuItem;
    Memo1: TMemo;
    Memo2: TMemo;
    clipazimuthelevation1: TMenuItem;
    Cut1: TMenuItem;
    Paste1: TMenuItem;
    PSScript1: TPSScript;
    Splitter1: TSplitter;
    ScriptMenu1: TMainMenu;
    Toosl1: TMenuItem;
    Compile1: TMenuItem;
    File1: TMenuItem;
    Exit1: TMenuItem;
    N1: TMenuItem;
    SaveAs1: TMenuItem;
    Save1: TMenuItem;
    Open1: TMenuItem;
    New1: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    N2: TMenuItem;
    Stop1: TMenuItem;
    Edit1: TMenuItem;
    Copy1: TMenuItem;
    Insert1: TMenuItem;
    Render1: TMenuItem;
    Mosaic1: TMenuItem;
    Contrast1: TMenuItem;
    Forms1: TMenuItem;
    SCRIPTFORMVISIBLE1: TMenuItem;
    CONTRASTFORMVISIBLE1: TMenuItem;
    CUTOUTFORMVISIBLE1: TMenuItem;
    CLIPFORMVISIBLE1: TMenuItem;
    MOSAICFORMVISIBLE1: TMenuItem;
    WAIT1: TMenuItem;
    loadimage1: TMenuItem;
    savebmp1: TMenuItem;
    Sliceviews1: TMenuItem;
    orthoview1: TMenuItem;
    Clip1: TMenuItem;
    backcolor1: TMenuItem;
    cameradistance1: TMenuItem;
    azimuth1: TMenuItem;
    elevation1: TMenuItem;
    cutout1: TMenuItem;
    maximumintensity1: TMenuItem;
    viewaxial1: TMenuItem;
    viewcoronal1: TMenuItem;
    viewsagittal1: TMenuItem;
    framevisible1: TMenuItem;
    setcolortable1: TMenuItem;
    CHANGENODE1: TMenuItem;
    addnode1: TMenuItem;
    contrastminmax1: TMenuItem;
    azimuthelevation1: TMenuItem;
    Dialogs1: TMenuItem;
    modalmessage1: TMenuItem;
    modelessmessage1: TMenuItem;
    Overlays1: TMenuItem;
    OverlayLoad1: TMenuItem;
    overlaycloseall1: TMenuItem;
    overlaycolornumber1: TMenuItem;
    overlaycolorname1: TMenuItem;
    overlayminmax1: TMenuItem;
    overlaytransparencybackground1: TMenuItem;
    overlaytransparencyoverlay1: TMenuItem;
    overlaycolorfromzero1: TMenuItem;
    overlayformvisible1: TMenuItem;
    perspective1: TMenuItem;
    colorname1: TMenuItem;
    colorbarvisible1: TMenuItem;
    Colorbar1: TMenuItem;
    colorbarcoord1: TMenuItem;
    colorbartext1: TMenuItem;
    SliceText1: TMenuItem;
    overlayloadsmooth1: TMenuItem;
    colorbarformvisible1: TMenuItem;
    edgedetect1: TMenuItem;
    overlaymaskedbybackground1: TMenuItem;
    resetdefaults1: TMenuItem;
    procedure  Readline(var lPosIn: integer);
    procedure Compile1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure SaveAs1Click(Sender: TObject);
    procedure OpenScript(lFilename: string);
    procedure Memo1Change(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Stop1Click(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
    procedure OpenMRU(Sender: TObject);//open template or MRU
    procedure UpdateMRU;
    procedure InsertCommand(Sender: TObject);
    procedure AdjustSelText;
    procedure PSScript1Compile(Sender: TPSScript);
    //procedure Writeln(Str: string);
    //procedure MyWriteln(const s: string);
    procedure Memo1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Memo1Click(Sender: TObject);
    procedure Cut1Click(Sender: TObject);
    procedure Paste1Click(Sender: TObject);
  private
    fn: string;
    gchanged: Boolean;
    function SaveTest: Boolean;
  public
    { Public declarations }
  end;
const
  kScriptExt = '.gls';
 kScriptFilter = 'NIfTI ('+kScriptExt+')|'+kScriptExt;
var
  ScriptForm: TScriptForm;

implementation
uses
    mainunit,userdir, prefs  ;
{$IFNDEF FPC}
{$R *.DFM}
{$ENDIF}

procedure MyWriteln(const s: string);
begin
  ScriptForm.Memo2.lines.add(S);
end;

function ScriptDir: string;
begin
  result := AppDir+'script'
end;

procedure TScriptForm.OpenMRU(Sender: TObject);//open template or MRU
//Templates have tag set to 0, Most-Recently-Used items have tag set to position in gMRUstr
begin
  if Sender = nil then begin
    if (gPrefs.PrevScriptName[1] <> '') and (Fileexists(gPrefs.PrevScriptName[1])) then
      OpenScript (gPrefs.PrevScriptName[1]);
  end else
    OpenScript (gPrefs.PrevScriptName[(Sender as TMenuItem).tag]);
end;

procedure TScriptForm.UpdateMRU;//most-recently-used menu
var
  NewItem: TMenuItem;
	lPos,lN : integer;
begin
  While File1.Count > 6 do File1.Items[6].Free;
  lN := 0;
  for lPos := 1 to knMRU do begin//for each MRU
      if gPrefs.PrevScriptName[lPos] <> '' then begin
		   inc(lN);
		   NewItem := TMenuItem.Create(Self);
		   NewItem.Caption :=ExtractFileName(gPrefs.PrevScriptName[lPos]);//(ParseFileName(ExtractFileName(lFName)));
		   NewItem.Tag := lN;
                   {$IFDEF FPC}
                    NewItem.onclick :=  OpenMRU; //Lazarus
                    {$ELSE}
                     NewItem.onclick :=  OpenMRU;
                     {$ENDIF}
		   //NewItem.ShortCut := ShortCut(Word('1')+ord(lN-1), [ssCtrl]);
		   File1.Add(NewItem);
      end;//if mru exists
  end;//for each MRU
end;  //UpdateMRU

procedure TScriptForm.PSScript1Compile(Sender: TPSScript);
var
   i: integer;
begin
  //Sender.AddFunction( @TScriptForm.MyWriteln,'procedure Writeln(const s: string);');
  Sender.AddFunction(@MyWriteln, 'procedure Writeln(s: string);');
  for i := 1 to knFunc do
      Sender.AddFunction(kFuncRA[i].Ptr,'function '+kFuncRA[i].Decl+kFuncRA[i].Vars+';');
  for i := 1 to knProc do
      Sender.AddFunction(kProcRA[i].Ptr,'procedure '+kProcRA[i].Decl+kProcRA[i].Vars+':');
end;

procedure TScriptForm.Compile1Click(Sender: TObject);
var
  i: integer;
  Messages: string;
  compiled: boolean;
begin
  Memo2.Lines.Clear;
  PSScript1.Script.Text := Memo1.Lines.GetText;
  Compiled := PSScript1.Compile;
  for i := 0 to PSScript1.CompilerMessageCount -1 do
    MyWriteln( PSScript1.CompilerMessages[i].MessageToString);
    {Messages := Messages +ce.CompilerMessages[i].MessageToString + #13#10;  }
  if Compiled then
    MyWriteln('Successfully Compiled Script');
  if Compiled then begin
    if PSScript1.Execute then
      MyWriteln('Succesfully Executed')
    else
      MyWriteln('Error while executing script: '+
                  PSScript1.ExecErrorToString);
    VideoEnd;
  end;
end;

procedure TScriptForm.FormCreate(Sender: TObject);
begin
  fn := '';
  gchanged := False;
  Memo1.Lines.Text := 'Program Sample;'#13#10'Begin'#13#10'MOSAIC(''0.25 0.5; 0.75 C 0.5'');'#13#10'End.';
  FillMRU (gPrefs.PrevScriptName, ScriptDir+pathdelim,kScriptExt,False);
  UpdateMRU;
  OpenMRU(nil);
  OpenDialog1.InitialDir := ScriptDir;
  SaveDialog1.InitialDir := ScriptDir;
 {$IFDEF Darwin}
        {$IFNDEF LCLgtk} //only for Carbon compile
        Cut1.ShortCut := ShortCut(Word('X'), [ssMeta]);
        Copy1.ShortCut := ShortCut(Word('C'), [ssMeta]);
        Paste1.ShortCut := ShortCut(Word('V'), [ssMeta]);

        Stop1.ShortCut := ShortCut(Word('H'), [ssMeta]);
         Compile1.ShortCut := ShortCut(Word('R'), [ssMeta]);
 {$ENDIF}
 {$ENDIF}
end;

function TScriptForm.SaveTest: Boolean;
begin
  result := True;
(*  if changed then
  begin
    case MessageDlg('File is not saved, save now?', mtWarning, mbYesNoCancel, 0) of
      mrYes:
        begin
          Save1Click(nil);
          Result := not changed;
        end;
      mrNo: Result := True;
    else
      Result := False;
    end;
  end
  else
    Result := True;
*)
end;

procedure TScriptForm.OpenScript(lFilename: string);
begin
  GLForm1.StopTimers;
  ScriptForm.Stop1Click(nil);
  if not fileexists (lFilename) then begin
    Showmessage('Can not find '+lFilename);
    exit;
  end;
    Memo1.Lines.LoadFromFile(lFileName);
    gchanged := False;

    Memo2.Lines.Clear;
    fn := lFileName;
    Add2MRU(gPrefs.PrevScriptName,fn);
	  UpdateMRU;
end;

procedure TScriptForm.Open1Click(Sender: TObject);
var
   lS: string;
begin
  if not SaveTest then
    exit;
  lS :=  GetCurrentDir;
  if not OpenDialog1.Execute then
    exit;
   SetCurrentDir(lS);
  OpenScript(OpenDialog1.FileName);
end;

procedure TScriptForm.Save1Click(Sender: TObject);
begin
  if fn = '' then
  begin
    Saveas1Click(nil);
  end
  else
  begin
    Memo1.Lines.SaveToFile(fn);
    gchanged := False;
    Add2MRU(gPrefs.PrevScriptName,fn);
	  UpdateMRU;
  end;
end;

procedure TScriptForm.SaveAs1Click(Sender: TObject);
begin
  SaveDialog1.FileName := '';
  if SaveDialog1.Execute then
  begin
    fn := SaveDialog1.FileName;
    Memo1.Lines.SaveToFile(fn);
    gchanged := False;
    Add2MRU(gPrefs.PrevScriptName,fn);
	  UpdateMRU;
  end;
end;

procedure TScriptForm.Memo1Change(Sender: TObject);
begin
     inherited;
  gchanged := True;
end;

procedure TScriptForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose := SaveTest;
end;

procedure TScriptForm.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TScriptForm.Stop1Click(Sender: TObject);
begin
  if PSScript1.Running then
    PSScript1.Stop;
end;

procedure TScriptForm.New1Click(Sender: TObject);
begin
  GLForm1.StopTimers;
  ScriptForm.Stop1Click(nil);
  if not SaveTest then
    exit;
  Memo1.Lines.Text := 'Program demo;'#13#10'Begin'#13#10'End.';
  Memo2.Lines.Clear;
  fn := '';
end;



procedure CleanStr (var lStr: string);
//remove symbols, set upcase...
var
  lLen,lPos: integer;
  lS: string;
begin
  lLen := length(lStr);
  if lLen < 1 then
    exit;
  lS := '';
  for lPos := 1 to lLen do
    if lStr[lPos] in ['0'..'9','a'..'z','A'..'Z'] then
      lS := lS + upcase(lStr[lPos]);
    lStr := lS;
end;

procedure TScriptForm.Readline(var lPosIn: integer);
var
  lS: string;
  lCh: char;
  lPos,lLen: integer;
begin
  lPos := lPosIn;
  lLen := length(Memo1.Lines.GetText);
  lS := '';
  //fx(lPos,lLen);
  while (lPos < lLen) and ((Memo1.Text[lPos] <> #10) or (lS = '')) do begin
     lCh := upcase(Memo1.Text[lPos]);
     //showmessage(lCh);
     if (lCh in ['A'..'Z']) then begin
      lS := lS + lCh;
     end;
     inc(lPos);
  end;
  if (lS = 'BEGIN') then
    lPosIn := lPos;
  //caption := lS;
end;

procedure TScriptForm.AdjustSelText;
var
  lPos: integer;
begin
  lPos := Memo1.SelStart;
  Memo1.SelLength := 0;
  if lPos < 1 then
    exit;
  while (lPos > 0) and (Memo1.Text[lPos] <> #10) do
    dec(lPos);
  //next move text to after BEGIN statement
  Readline(lPos);
  Memo1.SelStart := lPos;
end;

procedure TScriptForm.InsertCommand(Sender: TObject);
var
  lStr : string;
  lParams,lLoop,lType: integer;//1=boolean,2=integer,3=float,4=string[filename]
begin
  lType := (Sender as TMenuItem).Tag;
  lStr := (Sender as TMenuItem).Hint;
  if lStr <> '' then begin
          Memo2.Lines.Clear;

          Memo2.Lines.Add(lStr);
  end;
  lStr := (Sender as TMenuItem).Caption;
  CleanStr(lStr);
  if lType <> 0 then begin
    lStr := lStr+'(';
    lParams := 1;
    if lType > 9 then begin //e.g. 31 means three boolean values...
      lParams := lType div 10;
      lType := lType - (lParams*10);
    end;
    for lLoop := 1 to lParams do begin
     case lType of
      1:  lStr := lStr +'true';
      2:  lStr := lStr +'1';
      3:  begin
            if lLoop <= 3 then //for Cutout view, we need six values - make them different so this is a sensible cutout
              lStr := lStr +'0.5'
            else
              lStr := lStr +'1.0';
        end;
      4:  lStr := lStr +'''filename''';
      5: lStr := lStr + '''0.2 0.4 0.6; 0.8 S 0.5''';
      6: begin //byte
            if lLoop <= 3 then //for Cutout view, we need six values - make them different so this is a sensible cutout
              lStr := lStr +'1'
            else
              lStr := lStr +'255';
        end;
      else lStr := lStr + '''?''';
     end;
     if lLoop < lParams then
        lStr := lStr+', ';
    end;//for each loop
    lStr := lStr + ');';
  end else //no params
    lStr := lStr + ';';
  Clipboard.AsText := lStr;
  AdjustSelText;
  Memo1.SelText := (lStr)+ #13#10;
end;

procedure TScriptForm.Memo1Click(Sender: TObject);
var lPos : TPoint;
begin
  lPos := Memo1.CaretPos; //+1 as indexed from zero
  caption := parsefilename(extractfilename(gPrefs.PrevScriptName[1])) +'  '+inttostr(lPos.Y+1)+':'+inttostr(lPos.X+1);
end;

procedure TScriptForm.Memo1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  Memo1Click(nil);
end;

procedure TScriptForm.Copy1Click(Sender: TObject);
begin
  if length(Memo1.SelText) < 1 then
    Memo1.SelectAll;
  //Clipboard.AsText := Memo1.SelText;
  Memo1.CopyToClipboard;
end;

procedure TScriptForm.Cut1Click(Sender: TObject);
begin
  if length(Memo1.SelText) < 1 then
    Memo1.SelectAll;
  Memo1.CutToClipboard;
end;

procedure TScriptForm.Paste1Click(Sender: TObject);
begin
  Memo1.PasteFromClipboard;
end;

initialization
{$IFDEF FPC}
    {$I scriptengine.lrs}
{$ENDIF}
end.
